/*

 todo: set quantities
 todo: tie widget quntities to game variables
 todo: set up timeline
 todo: set up dynamics
 todo: set up dialogs
 todo: release resources?
 todo: allow events to, like, end the game, or whatever
 todo: playsample doesn't seem to work:/
 todo: when pop bars move left, blood spatter
 todo: as population decreases, blot out parts of the city
 todo: as population increases, add new bits in(i guess)

 todo: ALLOW INGAME RESTART
 */

#include <allegro.h>
#include <iostream>
#include <vector>
#include <list>
#include <stack>
#include <algorithm>
#include "boost/foreach.hpp"

using namespace std;

#define foreach BOOST_FOREACH

typedef double num;

BITMAP* buffer;
BITMAP* bigbuffer;

bool amountsign[4];
int amountperm[4];
bool swapxy;

#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"
#include "printwrap.hpp"
#include "jumpdat.hpp"

unsigned int levelmax=0;

const int ts=13;
char *statustext="";
bool warover=false;
bool quit=false;
bool leave=false;
int titletimer=0;
bool finishedtitle;

const unsigned int quantitycount[7]={1,2,3,4,3,3,4};
const unsigned int varcount[7]={1,1,1,1,2,2,2};
double amounts[4];

vector<string> emergencymessages;

char *nulltext="";
int col;
int screenshake;

void enable_buttons();


int consequences=0;

void drawPreface()
{
	clear_to_color(buffer, makecol(0,0,0));
}

inline double bind01(double v)
{
	if (v<-1)
		return -1;
	else if (v>1)
		return 1;
	else
		return v;
}

bool escpressed;

class IntroLoop
{
public:
	static void initialize()
	{
		escpressed=true;
		speed_count=0;
		titletimer=0;
		finishedtitle=false;
	}

	static bool quitcondition()
	{
		return quit||warover||finishedtitle;
	}

	static void logic()
	{
		titletimer++;

		if (titletimer>600||(mouse_b&1)||keypressed())
		{
			position_mouse(400,200);
			finishedtitle=true;
		}
	}

	static void draw()
	{
		clear_to_color(buffer,makecol(0,0,0));

		textout_ex(buffer, font, "increpare presents", 4, 50, makecol(100,100,100), makecol(0,0,0));

	}
};

class TitleLoop
{
private:
	static bool begin;
	static unsigned int selected;
	static bool upheld;
	static bool downheld;
	static bool spaceheld;
public:
	static void initialize()
	{
		playmusic(8);
		begin=false;
		selected=0;
		upheld=true;
		downheld=true;
		spaceheld=true;
		escpressed=true;
	}

	static void logic()
	{
		if (key[KEY_ESC]&&!escpressed)
			quit=true;
		escpressed=key[KEY_ESC];

		if (key[KEY_UP])
		{
			if (!upheld)
			{
				selected=(selected+1)%2;
				playsample(1);
				upheld=true;
			}
		}
		else
			upheld=false;

		if (key[KEY_DOWN])
		{
			if (!downheld)
			{
				selected=(selected+1)%2;
				playsample(1);
				downheld=true;
			}
		}
		else
			downheld=false;

		if (key[KEY_SPACE])
		{
			if (!spaceheld)
			{
				if (selected==0)
				{
					begin=true;
					playsample(0);
				}
				else
				{
					quit=true;
				}
			}
		}
		else
			spaceheld=false;

	}

	static bool quitcondition()
	{
		return quit||begin;
	}

	static void draw()
	{
		clear_to_color(buffer,makecol(0,0,0));
		textout_ex(buffer,font,"untigrand/ersatz",8,7,makecol(136,126,114),makecol(0,0,0));
		if (selected==0)
		{
			textout_ex(buffer,font,"Start",59,60,makecol(100,100,100),makecol(255,255,255));
			textout_ex(buffer,font,"Exit",59,82,makecol(255,255,255),makecol(0,0,0));
		}
		else
		{
			textout_ex(buffer,font,"Start",59,60,makecol(255,255,255),makecol(0,0,0));
			textout_ex(buffer,font,"Exit",59,82,makecol(100,100,100),makecol(255,255,255));
		}

	}

};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;

int scol(unsigned int n)
{
	if (n<=levelmax)
		return makecol(255,255,255);
	else
		return makecol(20,20,20);
}

class SelectLoop
	{
	private:
		static bool begin;
		static bool upheld;
		static bool downheld;
		static bool spaceheld;
	public:
		static unsigned int selected;
		static void initialize()
		{
			begin=false;
//			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;
			leave=false;
			playmusic(0);

		}

		static void logic()
		{
			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];

			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected-1+levelmax+1)%(levelmax+1);
					if (levelmax!=0)
						playsample(1);
					upheld=true;
				}
			}
			else
				upheld=false;

			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%(levelmax+1);
					if (levelmax!=0)
						playsample(1);
					upheld=true;
					downheld=true;
				}
			}
			else
				downheld=false;

			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					playsample(0);
					leave=true;
				}
			}
			else
				spaceheld=false;

		}

		static bool quitcondition()
		{
			return quit||leave||warover;
		}

		static void draw()
		{
			clear_to_color(buffer,makecol(0,0,0));
			textout_ex(buffer,font,"untigrand/ersatz",8,7,makecol(136,126,114),makecol(0,0,0));
			if (selected==0)
				textout_ex(buffer,font,"fold",54,30,makecol(255,10,10),makecol(0,0,0));
			else
				textout_ex(buffer,font,"fold",54,30,scol(0),makecol(0,0,0));

			if (selected==1)
				textout_ex(buffer,font,"cusp",54,40,makecol(255,10,10),makecol(0,0,0));
			else
				textout_ex(buffer,font,"cusp",54,40,scol(1),makecol(0,0,0));

			if (selected==2)
				textout_ex(buffer,font,"swallowtail",54,50,makecol(255,10,10),makecol(0,0,0));
			else
				textout_ex(buffer,font,"swallowtail",54,50,scol(2),makecol(0,0,0));

			if (selected==3)
				textout_ex(buffer,font,"butterfly",54,60,makecol(255,10,10),makecol(0,0,0));
			else
				textout_ex(buffer,font,"butterfly",54,60,scol(3),makecol(0,0,0));

			if (selected==4)
				textout_ex(buffer,font,"pyramid",54,70,makecol(255,10,10),makecol(0,0,0));
			else
				textout_ex(buffer,font,"pyramid",54,70,scol(4),makecol(0,0,0));

			if (selected==5)
				textout_ex(buffer,font,"purse",54,80,makecol(255,10,10),makecol(0,0,0));
			else
				textout_ex(buffer,font,"purse",54,80,scol(5),makecol(0,0,0));

			if (selected==6)
				textout_ex(buffer,font,"parabola",54,90,makecol(255,10,10),makecol(0,0,0));
			else
				textout_ex(buffer,font,"parabola",54,90,scol(6),makecol(0,0,0));


		}

	};

bool SelectLoop::begin=false;
unsigned int SelectLoop::selected=0;
bool SelectLoop::upheld=false;
bool SelectLoop::downheld=false;
bool SelectLoop::spaceheld=true;



bool pressed[5];
unsigned int curselected;
enum GameState {
	gs_selecting,
	gs_weather,
	gs_action
} gamestate;

string displaystring;
int turn;
const int maxturn=8;

#include "functions.hpp"

enum ScreenState {ss_ok,ss_fail};

struct GameSlice
{
	Dat pos;
	ScreenState screenstate;
};

GameSlice curslice;

stack<GameSlice> undos;

void inc(double& f)
{
	f+=delta;
	if (f>1)
		f=1;
}
void dec(double& f)
{
	f-=delta;
	if (f<-1)
		f=-1;
}

MoveInfo cursignal;
const MoveInfo nosignal = (MoveInfo) {r_none};
enum LevelState { ls_moving, ls_prompt, ls_red} levelstate;


void trysetstring(int i)
{
	if (i<0) return;

	if (!stringseen[i] && !jumpstrings[SelectLoop::selected][i].empty())
	{
		screenshake=30;
		curstring=jumpstrings[SelectLoop::selected][i];
		playsample(0);
		stringseen[i]=true;
		if (SelectLoop::selected==(levelmax) &&
			levelmax<(7-1))
			levelmax++;
		std::cout<<endl<<endl<<endl<<i<<endl<<endl<<endl;
	}
}


void processsignal(const MoveInfo& t)
{
	trysetstring(MoveInfoToInt(t));
}



template<int n>
class GameLoop
{
public:
	static MoveInfo recalc()
	{
		bool gothrough=curslice.screenstate!=ss_fail;
		MoveInfo mr = move<n>(curslice.pos);

		if (gothrough)
			switch (mr.movetype)
			{
				case r_none:
					curslice.screenstate=ss_ok;
					break;
				case r_jump:
					curslice.screenstate=ss_ok;
					break;
				case r_fail:
					curslice.screenstate=ss_fail;
					break;
			}
		undos.push(curslice);
		return mr;
	}
	static MoveInfo increment()
	{
		switch (curselected){
		case 0:
			inc(curslice.pos.a);
		break;
		case 1:
			inc(curslice.pos.b);
		break;
		case 2:
			inc(curslice.pos.c);
		break;
		case 3:
			inc(curslice.pos.d);
		break;
		};
		MoveInfo res=recalc();
		switch (res.movetype)
		{
			case r_none:
				break;
			case r_jump:
				res.jump.control=curselected;
				res.jump.controldir=1;
				break;
			case r_fail:
				res.fail.control=curselected;
				res.fail.controldir=1;
				break;
		}
		return res;
	}

	static MoveInfo decrement()
	{
		switch (curselected){
			case 0:
				dec(curslice.pos.a);
				break;
			case 1:
				dec(curslice.pos.b);
				break;
			case 2:
				dec(curslice.pos.c);
				break;
			case 3:
				dec(curslice.pos.d);
				break;
		};

		MoveInfo res=recalc();
		switch (res.movetype)
		{
			case r_none:
				break;
			case r_jump:
				res.jump.control=curselected;
				res.jump.controldir=0;
				break;
			case r_fail:
				res.fail.control=curselected;
				res.fail.controldir=0;
				break;
		}
		return res;
	}

	static void initialize()
	{
		for (int i=0;i<4;i++)
			amountsign[i]=rand()%2;

		swapxy=rand()%2;

		for (unsigned int i=0;i<quantitycount[n];i++)
			amountperm[i]=i;

		for (unsigned int i = 1;i<quantitycount[n];i++)
		{
			int j=rand()%(i+1);
			swap(amountperm[i],amountperm[j]);
		}

		for (unsigned int i=0;i<quantitycount[n];i++)
			std::cout<<"P "<<i<<","<<amountperm[i]<<endl;

		playmusic(n+1);
		while (!undos.empty())
			undos.pop();

		for (int i=0;i<STRINGCOUNT;i++)
			stringseen[i]=0;

		curstring=jumpstrings[SelectLoop::selected][0];

		levelstate=ls_moving;

		cursignal=nosignal;

		curslice=(GameSlice) {(Dat){0,0,0,0,0,0},ss_ok};
		undos.push(curslice);
		consequences=false;
		warover=false;
		leave=false;

		escpressed=true;


		for (int i=0;i<5;i++)
			pressed[i]=true;
		curselected=0;
		gamestate=gs_selecting;
		displaystring="";

		turn=0;

	}

	static bool quitcondition()
	{
		return quit||leave||warover;
	}

	static void logic()
	{
		if (key[KEY_UP]&&!pressed[0]&&gamestate==gs_selecting)
		{
			curselected=(curselected+( quantitycount[n]-1)) % quantitycount[n];
			if (quantitycount[n]>1)
				playsample(1);
		}
		else if (key[KEY_DOWN]&&!pressed[1]&&gamestate==gs_selecting)
		{
			curselected=(curselected+1) % quantitycount[n];
			if (quantitycount[n]>1)
				playsample(1);
		}


		if (key[KEY_SPACE]&&!pressed[4]&&gamestate==gs_selecting)
		{


		}

		if (key[KEY_LEFT]&&!key[KEY_RIGHT])
			cursignal=decrement();
		else if (key[KEY_RIGHT]&&!key[KEY_LEFT])
			cursignal=increment();
		else if (key[KEY_BACKSPACE]||key[KEY_DEL])
		{
			if (!undos.empty())
			{
				curslice=undos.top();
				undos.pop();
			}
			else
			{
				curslice=(GameSlice) {(Dat){0,0,0,0,0,0},ss_ok};
			}
		}

		if (key[KEY_ESC]&&!escpressed)
			leave=true;

		escpressed=key[KEY_ESC];

		pressed[0]=key[KEY_UP];
		pressed[1]=key[KEY_DOWN];
		pressed[2]=key[KEY_LEFT];
		pressed[3]=key[KEY_RIGHT];
		pressed[4]=key[KEY_SPACE];
		processsignal(cursignal);
	}

	static void draw()
	{
		clear_to_color(buffer,makecol(0,0,0));

		for (unsigned int i=0;i<4;i++)
		{
			rect(buffer, 0, 64+i*11, 159, 75+i*11, makecol(255,255,255));
			if (gamestate==gs_selecting&&curselected==i)
			{
				rect(buffer,1,65+i*11,158,74+i*11,makecol(255,0,0));
			}

			if (i<quantitycount[n])
				vline(buffer, 2+(0+157)/2+((0+157)*curslice.pos[i])/2, 65+i*11, 75+i*11, makecol(0,0,255));

		}

		//draw heights
		hline(buffer, 0, 64/2 + (64.0*bind01(curslice.pos.x/2.0f))/2.0f, 11, makecol(255,255,255));

		rect(buffer,0,0,11,64,makecol(255,255,255));
		rect(buffer,159-11,0,159,64,makecol(255,255,255));

		if (varcount[n]==2)
			hline(buffer, 159-11, 64/2 + (64.0*bind01(curslice.pos.y/2.0f))/2.0f, 159, makecol(255,255,255));
		else
			hline(buffer, 159-11, 64/2 + (64.0*bind01(curslice.pos.x/2.0f))/2.0f, 159, makecol(255,255,255));

		switch (curslice.screenstate)
		{
			case ss_ok:
				col=makecol(50,50,50);
				break;
			case ss_fail:
				col=makecol(255,0,0);
				break;
		};
		rectfill(buffer, 12, 0, 159-12, 63, col);
		printwrap(curstring,16,4,makecol(255,255,255), col,16);

		textout_ex(buffer, font, description[SelectLoop::selected][curselected], 4, 111, makecol(255,255,255), makecol(0,0,0));
	}

};

template<class T>
void loop()
{

	screenshake=0;
	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

//			if (key[KEY_ESC])
//				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();


		if (screenshake>0)
		{
			for (int i=0;i<50;i++)
			{
				putpixel(buffer, rand()%160, rand()%120, makecol(rand()%255,rand()%255,rand()%255));
			}

			clear_to_color(bigbuffer, makecol(0,0,0));
			for (int i=0;i<160;i++)
				for (int j=0;j<120;j++)
					rectfill(bigbuffer, i*4-1+rand()%3, j*4-1+rand()%3, i*4+2+rand()%3, j*4+2+rand()%3, getpixel(buffer, i, j));
			int r1=(rand()%screenshake) - (screenshake/2);
			int r2=(rand()%screenshake) - (screenshake/2);

			blit(bigbuffer, screen, 0, 0, r1, r2, 640, 480);
			screenshake--;


		}
		else
		{
			for (int i=0;i<50;i++)
			{
				int r=rand()%100;
				putpixel(buffer, rand()%160, rand()%120, makecol(r,r,r));
			}

			clear_to_color(bigbuffer, makecol(0,0,0));
			for (int i=0;i<160;i++)
				for (int j=0;j<120;j++)
						rectfill(bigbuffer, i*4-1+rand()%3, j*4-1+rand()%3, i*4+2+rand()%3, j*4+2+rand()%3, getpixel(buffer, i, j));
			blit(bigbuffer, screen, 0, 0, 0, 0, 640, 480);
		}
//		stretch_blit(buffer,screen,0,0,160,120,0,0,640,480);
	}
}




void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(30));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;

	//init the buffer
	buffer=create_bitmap(160,120);
	bigbuffer=create_bitmap(640,480);

}

int dir;
int px;
int py;

int main(int argc, char *argv[])
{

	init();


	loop<IntroLoop>();

titletag:

	loop<TitleLoop>();

	while (!quit)
	{
		loop<SelectLoop>();

		if (quit)
		{
			quit=false;
			goto titletag;
		}

		switch (SelectLoop::selected)
		{
			case 0:
				loop<GameLoop <0> >();
				break;
			case 1:
				loop<GameLoop <1> >();
				break;
			case 2:
				loop<GameLoop <2> >();
				break;
			case 3:
				loop<GameLoop <3> >();
				break;
			case 4:
				loop<GameLoop <4> >();
				break;
			case 5:
				loop<GameLoop <5> >();
				break;
			case 6:
				loop<GameLoop <6> >();
				break;
		}


	}

	return 0;
}
END_OF_MAIN()
